
#pragma once

#include "FavoriteView.h"
#include "RecentContacts.h"

class CChatUser;
//class CNMDropTarget2TreeCtrl;
class CCurrentChatBuddyController;
class MainFrame;

class FavoriteController : public IGTWASActorEvent
{
public:
	FavoriteController(void);
	~FavoriteController(void);

	FavoriteView* GetFavoriteView(){ return &m_favoriteView;};
	CBuddyTreeCtrl*  GetTreeCtrl()
	{
		return m_favoriteView.GetTreeCtrl();
	}
	void InitFavoriteList();
	void InitFavoriteList574();

	void RedrawGroup(){m_favoriteView.RedrawGroup();}

	void CreateAllBuddyItem();
	void CreateAllGroupItem();
	void CreateAllBuddyItem574();
	void CreateAllGroupItem574();
	void ClearFavoriteList();

	void InitView(CWnd* pParentWnd);
	void SetList(CBuddyTreeCtrl* pBuddyList);
	void MoveView(LPRECT lpRect);

	BOOL IsBuddySelected() const;
	BOOL IsGroupSelected() const;
	//BOOL IsOnlineSelected() const;

	list<wstring> GetRecentContactUsers();

	//bUniqueUserID: when we select same user in defferent group, 
	//if we want to chat , the UserID need unique, 
	//if we want delete those node in group, UserId need not unique(same userid but not same id in CBubbyUser).
	int GetSelectedBuddyItems(std::vector<const IGTBuddyUser*>& buddyUserVector, bool bUniqueUserID = true);
	int GetSelectedFavoritesCount();
	int GetSelectedOnlineFavorites(std::vector<const IGTBuddyUser*>& buddyUserVector);
	int GetSelectedOnlineFavoritesCount();
	int GetSelectedTargetGroupID();
	std::vector<Node*> GetSelectedBuddyItems(void);
	const std::vector<Node*> GetSelectedItems(void);
	
	bool IsExistGroup(LPCWSTR strUserID, int nGroupID);
	BOOL RequestAddGroup();
	//BOOL RequestImportGroup(const CString strGroupName);
	void RequestDeleteGroup(const IGTBuddyGroup* pGroup = NULL);
	void DeleteGroup(int nGroupID);

	void GroupResort();
	void ExportGroup( std::vector<const IGTBuddyGroup* > groupVector, CString exportDefaultName, HWND hParentWnd=NULL );

	void WriteUserID( LPCWSTR strID, ofstream &ofs );

	vector<IMPORT_GROUP>* GetGroupInfoFromFile(HWND hParentWnd);
	void ImportGroup();

	int ReadGroupInfoFromFileUserCount(const CString strImportFileName );
	BOOL ReadGroupInfoFromFile(const CString strImportFileName, BOOL bUseNewGroupName = TRUE);

	int GetSelectedGroupItems(std::vector<const IGTBuddyGroup*>& groupVector);
	int GetAllGroupItems(std::vector<const IGTBuddyGroup*>& groupVector);
	const CString GetNewGroupName(const CString strDefaultName);

	void RequestDeleteBuddy();
	void RequestDeleteBuddy(std::vector<const IGTBuddyUser*> &vecSelectedBuddy);
	void DeleteBuddy(LPCWSTR strUserId, int nGroupId);
	BOOL RequestAddBuddy(int nGroupId, std::vector<wstring> vecBuddyID);
	void AddBuddy(const IGTBuddyUser *pUser);
	void DeleteBuddyInDeque(LPCWSTR lpUserID);
	BOOL OnNewRecentContact(CString strContactUserID);
	void AddRecentContactBuddy(deque<CString>& buddys);
	bool RequestMoveBuddy(std::vector<int> &vecBuddyID, int nToGroupId/*, std::vector<int> &vecDelBuddyID*/);
	void MoveBuddy(int nFromGroupID, const IGTBuddyUser* pUser);
	bool RequestSortGroup(std::vector<GT_BUDDY_GROUP_DATA> &vecGroupData);
	void ResortBuddyInGroup(int nGroupID);

	//void AddGroup(const IGTBuddyGroup* pGroup, bool bEditLabel = false);
	void AddGroup574(const IGTBuddyGroup* pGroup, bool bEditLabel = false);
	void AddRecentContactRroup(CString strGroupName,  bool bExpand = false);

	//void ImportUsers( const IGTBuddyGroup* pGroup );

	void EditLableOn(const IGTBuddyGroup * pGroup = NULL);
	void UpdateGroupName(const IGTBuddyGroup* pGroup);
	void UpdateRecentContactGroupName();

	void MenuMoveBuddy(UINT nCmdID , int nMenuStartID);
	void MenuCopyBuddy(UINT nCmdID , int nMenuStartID);
	

	void OnRButtonEvent( bool bDown, int nIndex );

	trid_t GetTrid() const;
	std::vector<std::wstring> GetTargetGroupNameList(int nGroupID = -1);
	std::vector<int> GetTargetGroupIdList(int nGroupID = -1);
    

	void UpdateStatus(IGTMessengerActor *pActor, LPCWSTR strBuddyID);
	void UpdateAllBuddyDisplayNames();

	void CarryDragDrop(HGLOBAL hGlobal);

	void CheckEffectiveBubbys();
	int GetRecentContactGroupOnlineBuddyCount();
	int GetGroupOnlineBuddyCount( const IGTBuddyGroup* pGroup );
	int GetGroupBuddyCount(const IGTBuddyGroup* pGroup);
	int GetRecentContactGroupBuddyCount();
	const std::vector<const IGTBuddyUser*> GetGroupOnlineBuddyList( const IGTBuddyGroup* pGroup );
	const std::vector<const IGTBuddyUser*> GetGroupBuddyList( const IGTBuddyGroup* pGroup );
	
	const CString GetItemDisplayText(const IGTBuddyUser* pUser);
	const CString GetItemWorkStatusText(const IGTBuddyUser* pUser);
	void SetCurrentChatBuddy(LPCWSTR strID);

	virtual bool OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID);
private:
	const CString GetFilterName(const CString& strDisplayName,int Optflag) const;
	int ProcDelFavorite(std::vector<const IGTBuddyUser*> &vecSelectedBuddy);
	void ChangeFavoriteStatusIcon(IGTMessengerActor *pActor, HTREEITEM hItem, LPCWSTR strBuddyID);
	void ChangeFavoriteStatusIcon(HTREEITEM hItem, LPCWSTR strBuddyID, int type);
	
	const CString GetGroupBuddyCountString(const IGTBuddyGroup* pGroup);
	const CString GetRecentContactGroupBuddyCountString(const CString& strGroupName);
	void SetOleDropTarget();
	bool IsNotInBuddyVector( std::vector<const IGTBuddyUser*> &buddyUserVector, CString strUserID );
	bool IsNotInBuddyVector( std::vector<const IGTBuddyUser*> &buddyUserVector, int nID );
	const CString GetExportFileName(BOOL bOpenFileDialog, CString strDefaultName, HWND hParentWnd=NULL);
	BOOL IsMyUserID(LPCWSTR strID);

	LPCWSTR GetMyUserID();
	void CreateCurrentChatGroup();
	void CreateCurrentChatBuddyList();
	
	void RequestRegiRecentGroupToPOI(LPCTSTR lpStr);
	void RequestUnRegiRecentGroupToPOI(LPCTSTR lpStr);
	
	int HitTestGroupId();
	FavoriteView m_favoriteView;
	//CNMDropTarget2TreeCtrl* m_pBuddyDropTarget;
	std::vector<IMPORT_GROUP>  m_ImportGroupVector;
	int m_ImportGroupCount;
	BOOL m_bImport;
	CCurrentChatBuddyController* m_pCurrentChatBuddyController;
	CRecentContacts* m_pRecentContact;
	deque<CString> m_Buddys;
    IGTBuddyGroup* m_pRecentContactBuddyGroup;
	CCriticalSection	m_csBubbys;
	BOOL			m_bCreatedRecentContactGroup;
	trid_t m_nTridGetBuddy;	//TODO: class variable
};
